local interfaceMngr = nil;

local Types = {}

local bulletinBoardPostsForm = {};
local bulletinBoardAddPostForm = {};

function Init()
	
	interfaceMngr = GetInterfaceManager();

	bulletinBoardPostsForm.Form = interfaceMngr:CreateForm("Bulletin Board", "Script");
	
	local ribbonPage = bulletinBoardPostsForm.Form:CreateRibbonPage("Bulletin Board");
	ribbonPage:CreateButton("Refresh", GetClientImage("Refresh32"), "RefreshBB", "Bulletin Board");
	ribbonPage:CreateButton("Add Post", GetClientImage("Add32"), "AddPost", "Bulletin Board");
	
	bulletinBoardPostsForm.PostsGrid = bulletinBoardPostsForm.Form:CreateGrid("PostsGrid", "PostsGrid");
	bulletinBoardPostsForm.PostsGrid.TextVisible = false;
	
	bulletinBoardPostsForm.PostBodyMemoEdit = bulletinBoardPostsForm.Form:CreateMemoEdit("Post Text", "Post Text");
	bulletinBoardPostsForm.PostBodyMemoEdit.TextVisible = false;
	bulletinBoardPostsForm.PostBodyMemoEdit.Editor.Properties.ReadOnly = true;
	
	
	LoadTypes();
	bulletinBoardPostsForm.PostsGrid.GridControl.MainView.FocusedRowChanged:Add(postsGridView_SelectedPostChanged)
	RefreshBB();
	
	bulletinBoardPostsForm.Form:Show();
end

function GetConnection()
	return CreateDatabaseConnection(GetSetting("DatabaseConnectionPath"));
end

function RefreshBB()
	local connection = GetConnection();
	connection.QueryString = "SELECT DatePosted, Subject, Author, Location, Symbol, Body FROM Posts ORDER BY DatePosted DESC";
	
	connection:Connect();	
	local postsTable = connection:Execute();
	connection:Disconnect();
		
	bulletinBoardPostsForm.PostsGrid.PrimaryTable = postsTable;
	bulletinBoardPostsForm.PostsGrid.GridControl.MainView.OptionsBehavior.Editable = false;
	bulletinBoardPostsForm.PostsGrid.GridControl.MainView.Columns:get_Item("Body").Visible = false;
	bulletinBoardPostsForm.PostsGrid.GridControl.MainView.Columns:get_Item("DatePosted").Caption = "Date";
	bulletinBoardPostsForm.PostsGrid.GridControl.MainView.Columns:get_Item("DatePosted").Width = 130;
	bulletinBoardPostsForm.PostsGrid.GridControl.MainView.Columns:get_Item("DatePosted").DisplayFormat.FormatString = "g"
	bulletinBoardPostsForm.PostsGrid.GridControl.MainView.Columns:get_Item("Subject").Width = 300;
	bulletinBoardPostsForm.PostsGrid.GridControl.MainView.Columns:get_Item("Location").Width = 200;
	
end

function LoadTypes()
	luanet.load_assembly("System.Data");
	luanet.load_assembly("System.Data.OleDb");
	Types["OleDbType"] = luanet.import_type("System.Data.OleDb.OleDbType");
end

function postsGridView_SelectedPostChanged(sender, args)
	if bulletinBoardPostsForm.PostsGrid.GridControl.MainView:IsDataRow(args.FocusedRowHandle) then
		UpdatePostText();
	end
end

function UpdatePostText()
	bulletinBoardPostsForm.PostBodyMemoEdit.Value = bulletinBoardPostsForm.PostsGrid.GridControl.MainView:GetFocusedRowCellValue("Body");
end
